/**!
   * mongodash v1.1.1
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2021 Václav Oborník
   * Released under the MIT license
   */
  'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCollection = exports.init = void 0;
const getMongoClient_1 = require("./getMongoClient");
let collectionFactory;
function init(options) {
    collectionFactory = options.collectionFactory;
}
exports.init = init;
let depthCallCounter = 0;
function getCollection(name) {
    try {
        depthCallCounter++;
        if (collectionFactory && depthCallCounter === 1) {
            const collection = collectionFactory(name);
            if (collection) {
                return collection;
            }
        }
        return (0, getMongoClient_1.getMongoClient)().db().collection(name);
    }
    finally {
        depthCallCounter--;
    }
}
exports.getCollection = getCollection;
//# sourceMappingURL=getCollection.js.map