/**!
   * mongodash v1.1.1
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2021 Václav Oborník
   * Released under the MIT license
   */
  'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = exports.getMongoClient = void 0;
const mongodb_1 = require("mongodb");
let mongoClientInstance;
function getMongoClient() {
    if (!mongoClientInstance) {
        throw Error('The mongodash.init() has to be called first.');
    }
    return mongoClientInstance;
}
exports.getMongoClient = getMongoClient;
async function init(options) {
    if ('mongoClient' in options) {
        if ('clientOptions' in options) {
            throw new Error('It is not possible use clientOptions with ready mongoClient instance.');
        }
        if ('uri' in options) {
            throw new Error('It is not possible use uri with ready mongoClient instance.');
        }
        mongoClientInstance = options.mongoClient;
    }
    else if ('uri' in options) {
        mongoClientInstance = new mongodb_1.MongoClient(options.uri, options.clientOptions);
    }
    else {
        throw new Error('The `mongoClient` or the connection `uri` parameter has to be specified.');
    }
    if (options.autoConnect) {
        await mongoClientInstance.connect();
    }
}
exports.init = init;
//# sourceMappingURL=getMongoClient.js.map