/**!
   * mongodash v1.1.1
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2021 Václav Oborník
   * Released under the MIT license
   */
  "use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = exports.withTransaction = exports.LockAlreadyAcquiredError = exports.isLockAlreadyAcquiredError = exports.withLock = exports.getMongoClient = exports.getCollection = exports.stopCronTasks = exports.startCronTasks = exports.scheduleCronTaskImmediately = exports.runCronTask = exports.cronTask = void 0;
const cronTasks_1 = require("./cronTasks");
const getCollection_1 = require("./getCollection");
const getMongoClient_1 = require("./getMongoClient");
const withLock_1 = require("./withLock");
const initPromise_1 = require("./initPromise");
var cronTasks_2 = require("./cronTasks");
Object.defineProperty(exports, "cronTask", { enumerable: true, get: function () { return cronTasks_2.cronTask; } });
Object.defineProperty(exports, "runCronTask", { enumerable: true, get: function () { return cronTasks_2.runCronTask; } });
Object.defineProperty(exports, "scheduleCronTaskImmediately", { enumerable: true, get: function () { return cronTasks_2.scheduleCronTaskImmediately; } });
Object.defineProperty(exports, "startCronTasks", { enumerable: true, get: function () { return cronTasks_2.startCronTasks; } });
Object.defineProperty(exports, "stopCronTasks", { enumerable: true, get: function () { return cronTasks_2.stopCronTasks; } });
var getCollection_2 = require("./getCollection");
Object.defineProperty(exports, "getCollection", { enumerable: true, get: function () { return getCollection_2.getCollection; } });
var getMongoClient_2 = require("./getMongoClient");
Object.defineProperty(exports, "getMongoClient", { enumerable: true, get: function () { return getMongoClient_2.getMongoClient; } });
var withLock_2 = require("./withLock");
Object.defineProperty(exports, "withLock", { enumerable: true, get: function () { return withLock_2.withLock; } });
Object.defineProperty(exports, "isLockAlreadyAcquiredError", { enumerable: true, get: function () { return withLock_2.isLockAlreadyAcquiredError; } });
Object.defineProperty(exports, "LockAlreadyAcquiredError", { enumerable: true, get: function () { return withLock_2.LockAlreadyAcquiredError; } });
var withTransaction_1 = require("./withTransaction");
Object.defineProperty(exports, "withTransaction", { enumerable: true, get: function () { return withTransaction_1.withTransaction; } });
let initCalled = false;
const defaultOnError = (error) => {
    console.error(error);
};
async function init(options) {
    var _a, _b, _c, _d, _e;
    if (initCalled) {
        throw new Error('init method can be called only once.');
    }
    initCalled = true;
    const _onError = (_a = options.onError) !== null && _a !== void 0 ? _a : defaultOnError;
    const onError = (error) => {
        try {
            _onError(error);
        }
        catch (onErrorFailure) {
            // intentionally suppress
        }
    };
    (0, getCollection_1.init)({ collectionFactory: (_b = options.collectionFactory) !== null && _b !== void 0 ? _b : null });
    (0, withLock_1.init)({ onError });
    (0, cronTasks_1.init)({
        runCronTasks: (_c = options.runCronTasks) !== null && _c !== void 0 ? _c : true,
        cronExpressionParserOptions: (_d = options.cronExpressionParserOptions) !== null && _d !== void 0 ? _d : {},
        onError,
    });
    await (0, getMongoClient_1.init)(Object.assign(Object.assign({}, options), { autoConnect: (_e = options.autoConnect) !== null && _e !== void 0 ? _e : true }));
    initPromise_1.resolver.resolve();
}
exports.init = init;
//# sourceMappingURL=index.js.map