/**!
   * mongodash v1.1.1
   * https://github.com/VaclavObornik/mongodash.git
   *
   * Copyright (c) 2021 Václav Oborník
   * Released under the MIT license
   */
  'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.withTransaction = void 0;
const getMongoClient_1 = require("./getMongoClient");
async function withTransaction(callback, options) {
    const clientSession = (0, getMongoClient_1.getMongoClient)().startSession();
    try {
        let returnValue;
        await clientSession.withTransaction(async () => {
            returnValue = await callback(clientSession);
        }, options);
        return returnValue; // eslint-disable-line @typescript-eslint/no-non-null-assertion
    }
    finally {
        await clientSession.endSession();
    }
}
exports.withTransaction = withTransaction;
//# sourceMappingURL=withTransaction.js.map