import { ParserOptions as CronExpressionParserOptions } from 'cron-parser';
import { OnError } from './OnError';
export declare type TaskFunction = () => Promise<unknown> | void;
export declare type ScalarInterval = number | string;
export declare type StaticInterval = ScalarInterval | Date;
export declare type IntervalFunction = () => StaticInterval | Promise<StaticInterval>;
export declare type Interval = ScalarInterval | IntervalFunction;
export declare type TaskId = string;
export declare function runCronTask(taskId: TaskId): Promise<void>;
export declare type InitOptions = {
    runCronTasks: boolean;
    cronExpressionParserOptions: CronExpressionParserOptions;
    onError: OnError;
};
export declare function init({ runCronTasks, cronExpressionParserOptions, onError }: InitOptions): void;
export declare function stopCronTasks(): void;
export declare function startCronTasks(): void;
export declare function scheduleCronTaskImmediately(taskId: TaskId): Promise<void>;
export declare function cronTask(taskId: TaskId, interval: Interval, task: TaskFunction): Promise<void>;
