import { InitOptions as CronTasksInitOptions } from './cronTasks';
import { InitOptions as GetCollectionInitOptions } from './getCollection';
import { InitOptions as GetMongoClientInitOptions } from './getMongoClient';
export { cronTask, Interval, runCronTask, scheduleCronTaskImmediately, startCronTasks, stopCronTasks, TaskFunction, TaskId } from './cronTasks';
export { getCollection } from './getCollection';
export { getMongoClient } from './getMongoClient';
export { OnError } from './OnError';
export { withLock, isLockAlreadyAcquiredError, WithLockOptions, LockAlreadyAcquiredError } from './withLock';
export { withTransaction } from './withTransaction';
export declare type InitOptions = GetMongoClientInitOptions & Partial<CronTasksInitOptions> & Partial<GetCollectionInitOptions>;
export declare function init(options: InitOptions): Promise<void>;
