import { ObjectId } from 'mongodb';
import { OnError } from './OnError';
export declare function init(options: {
    onError: OnError;
}): void;
export declare type LockKey = string | number | ObjectId;
export declare type LockCallback<T> = () => Promise<T>;
export declare type WithLockOptions = {
    maxWaitForLock?: number;
    startingDelay?: number;
    expireIn?: number;
};
export declare class LockAlreadyAcquiredError extends Error {
    readonly key: LockKey;
    constructor(key: LockKey);
}
export declare function isLockAlreadyAcquiredError(err: unknown, key?: LockKey): boolean;
export declare function withLock<T>(key: LockKey, callback: LockCallback<T>, { maxWaitForLock, startingDelay, expireIn }?: WithLockOptions): Promise<T>;
